diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.c b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.c
index 8a9ffdee8c212337cfccead7c07bad946b4b44e5..8a92d361481ae1d9cdd26057d8ba1cb79502f8df 100755
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.c
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.c
@@ -680,34 +422,13 @@ PBIST_TestHandle_t PBIST_TestHandleArray[PBIST_MAX_INSTANCE+1] =
         .numAuxDevices          = MSMC_NUM_AUX_DEVICES,           /* No Aux devices       */
         .auxDeviceIdsP          = &PBIST_MSMCAuxDevList[0],       /* Array of Aux device ids */
         .auxInitRestoreFunction = NULL,                           /* Auxilliary init/restore function */
-        .doneFlag               = false,                          /* Initialize done flag */
     },
     /* Encoder */
     {
-        .testName            = "Encoder PBIST",
-        .numPostPbistToCheck = 0u,
-        .PBISTRegsHiAddress  = 0u,
-        .pPBISTRegs          = (CSL_pbistRegs *)CSL_PBIST2_BASE,
-        .numPBISTRuns        = CSL_PBIST2_NUM_TEST_VECTORS,
-        .PBISTConfigRun = {
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_PBIST2_ALGO_BITMAP_0,   /* Choose recommended Algo bitmap 0 */
-                .memoryGroupsBitMap = CSL_PBIST2_MEM_BITMAP_0,    /* Choose recommended mem bitmap 0  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value */
-            },
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_PBIST2_ALGO_BITMAP_1,   /* Choose recommended Algo bitmap 1 */
-                .memoryGroupsBitMap = CSL_PBIST2_MEM_BITMAP_1,    /* Choose recommended mem bitmap 1  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value */
-            },
-
-        },
+        .testName               = "Encoder PBIST",
+        .pbistInst              = SDL_PBIST_INST_ENCODER,
+        .numPostPbistToCheck    = 0u,
         .tisciPBISTDeviceId     = TISCI_DEV_PBIST2,   /* PBIST device id  */
-        .interruptNumber        = CSLR_MCU_R5FSS0_CORE0_INTR_PBIST2_DFT_PBIST_CPU_0,
         .procRstNeeded          = false,
         .secondaryCoreNeeded    = false,                /* Secondary core needed */
         .coreName               = "Encoder",            /* Primary core          */
@@ -716,36 +437,13 @@ PBIST_TestHandle_t PBIST_TestHandleArray[PBIST_MAX_INSTANCE+1] =
         .coreCustPwrSeqNeeded   = false,
         .numAuxDevices          = 0u,                   /* No Aux devices        */
         .auxInitRestoreFunction = NULL,                 /* Auxilliary init/restore function */
-        .doneFlag               = false,                /* Initialize done flag  */
     },
-    /* Remaining PBIST sections are not currently supported in BootApp */
-#if 0
     /* Decoder */
     {
-        .testName            = "Decoder PBIST",
-        .numPostPbistToCheck = 0u,
-        .PBISTRegsHiAddress  = 0u,
-        .pPBISTRegs          = (CSL_pbistRegs *)CSL_PBIST0_BASE,
-        .numPBISTRuns        = CSL_PBIST0_NUM_TEST_VECTORS,
-        .PBISTConfigRun = {
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_PBIST0_ALGO_BITMAP_0,   /* Choose recommended Algo bitmap 0 */
-                .memoryGroupsBitMap = CSL_PBIST0_MEM_BITMAP_0,    /* Choose recommended mem bitmap 0  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value */
-            },
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_PBIST0_ALGO_BITMAP_1,   /* Choose recommended Algo bitmap 1 */
-                .memoryGroupsBitMap = CSL_PBIST0_MEM_BITMAP_1,    /* Choose recommended mem bitmap 1  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value          */
-            },
-
-        },
+        .testName               = "Decoder PBIST",
+        .pbistInst              = SDL_PBIST_INST_DECODER,
+        .numPostPbistToCheck    = 0u,
         .tisciPBISTDeviceId     = TISCI_DEV_PBIST0,            /* PBIST device id  */
-        .interruptNumber        = CSLR_MCU_R5FSS0_CORE0_INTR_PBIST0_DFT_PBIST_CPU_0,
         .procRstNeeded          = false,
         .secondaryCoreNeeded    = false,                       /* Secondary core needed */
         .coreName               = "Decoder",                   /* Primary core          */
@@ -754,34 +452,15 @@ PBIST_TestHandle_t PBIST_TestHandleArray[PBIST_MAX_INSTANCE+1] =
         .coreCustPwrSeqNeeded   = false,
         .numAuxDevices          = 0u,                          /* No Aux devices        */
         .auxInitRestoreFunction = PBIST_decoderAuxInitRestore, /* Auxilliary init/restore function */
-        .doneFlag               = false,                       /* Initialize done flag  */
     },
+    /* Remaining PBIST sections are not currently supported in BootApp */
+#if 0
     /* GPU */
     {
-        .testName            = "GPU PBIST",
-        .numPostPbistToCheck = 0u,
-        .PBISTRegsHiAddress  = CSL_COMPUTE_CLUSTER0_MSMC_PBIST_BASE,
-        .pPBISTRegs          = (CSL_pbistRegs *)CSL_GPU0_PBIST_CFG_BASE,
-        .numPBISTRuns        = CSL_GPU0_DFT_PBIST_0_NUM_TEST_VECTORS,
-        .PBISTConfigRun = {
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_GPU0_DFT_PBIST_0_ALGO_BITMAP_0,   /* Choose recommended Algo bitmap 0 */
-                .memoryGroupsBitMap = CSL_GPU0_DFT_PBIST_0_MEM_BITMAP_0,    /* Choose recommended mem bitmap 0  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value        */
-            },
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_GPU0_DFT_PBIST_0_ALGO_BITMAP_1,   /* Choose recommended Algo bitmap 1 */
-                .memoryGroupsBitMap = CSL_GPU0_DFT_PBIST_0_MEM_BITMAP_1,    /* Choose recommended mem bitmap 1  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value          */
-            },
-
-        },
-        .tisciPBISTDeviceId     = TISCI_DEV_GPU0,         /* PBIST device id  */
-        .interruptNumber        = CSLR_MCU_R5FSS0_CORE0_INTR_GPU0_DFT_PBIST_0_DFT_PBIST_CPU_0,
+        .testName               = "GPU PBIST",
+        .pbistInst              = SDL_PBIST_INST_GPU,
+        .numPostPbistToCheck    = 0u,
+        .tisciPBISTDeviceId     = TISCI_DEV_GPU0_DFT_PBIST_0, /* PBIST device id  */
         .procRstNeeded          = false,
         .secondaryCoreNeeded    = false,                    /* Secondary core needed */
         .coreName               = "GPU",                    /* Primary core   */
@@ -791,34 +470,13 @@ PBIST_TestHandle_t PBIST_TestHandleArray[PBIST_MAX_INSTANCE+1] =
         .numAuxDevices          = GPU_NUM_AUX_DEVICES,      /* Number of Aux devices   */
         .auxDeviceIdsP          = &PBIST_GPUAuxDevList[0],  /* Array of Aux device ids */
         .auxInitRestoreFunction = PBIST_GPUAuxInitRestore,  /* Auxilliary init/restore function */
-        .doneFlag               = false,                    /* Initialize done flag */
     },
     /* DSS EDP DSI */
     {
-        .testName            = "DSS EDP PBIST",
-        .numPostPbistToCheck = 0u,
-        .PBISTRegsHiAddress  = CSL_COMPUTE_CLUSTER0_MSMC_PBIST_BASE,
-        .pPBISTRegs          = (CSL_pbistRegs *)PBIST_REGION_LOCAL_BASE,
-        .numPBISTRuns        = CSL_PBIST4_NUM_TEST_VECTORS,
-        .PBISTConfigRun = {
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_PBIST4_ALGO_BITMAP_0,   /* Choose recommended Algo bitmap 0 */
-                .memoryGroupsBitMap = CSL_PBIST4_MEM_BITMAP_0,    /* Choose recommended mem bitmap  0 */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value */
-            },
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use algorithmsBitMap & memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_PBIST4_ALGO_BITMAP_1,   /* Choose recommended Algo bitmap 1 */
-                .memoryGroupsBitMap = CSL_PBIST4_MEM_BITMAP_1,    /* Choose recommended mem bitmap  1 */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value */
-            },
-
-        },
+        .testName               = "DSS EDP PBIST",
+        .pbistInst              = SDL_PBIST_INST_DSS,
+        .numPostPbistToCheck    = 0u,
         .tisciPBISTDeviceId     = TISCI_DEV_PBIST4,        /* PBIST device id  */
-        .interruptNumber        = CSLR_MCU_R5FSS0_CORE0_INTR_PBIST4_DFT_PBIST_CPU_0,
         .procRstNeeded          = false,
         .secondaryCoreNeeded    = false,                   /* Secondary core needed */
         .coreName               = "DSS",                   /* Primary core   */
@@ -828,33 +486,18 @@ PBIST_TestHandle_t PBIST_TestHandleArray[PBIST_MAX_INSTANCE+1] =
         .numAuxDevices          = DSS_NUM_AUX_DEVICES,     /* Number of Aux devices   */
         .auxDeviceIdsP          = &PBIST_DSSAuxDevList[0], /* Array of Aux device ids */
         .auxInitRestoreFunction = NULL,                    /* Auxilliary init/restore function */
-        .doneFlag               = false,                   /* Initialize done flag */
     },
     /* MCU PULSAR PBIST */
     {
-        .testName            = "MCU PULSAR PBIST",
-        .numPostPbistToCheck = 0u,
-        .PBISTRegsHiAddress  = 0u,
-        .pPBISTRegs          = (CSL_pbistRegs *)CSL_MCU_PBIST1_BASE,
-        .numPBISTRuns        = CSL_MCU_PBIST1_NUM_TEST_VECTORS,
-        .PBISTConfigRun = {
-            {
-                .override           = 0x0u,
-                /* Override bit set to 0 to use memoryGroupsBitMap */
-                .algorithmsBitMap   = CSL_MCU_PBIST1_ALGO_BITMAP_0,   /* Choose recommended Algo bitmap */
-                /* NOTE: As the MCU R5f is running this code override bit cannot be set to enable all memory test */
-                .memoryGroupsBitMap = CSL_MCU_PBIST1_MEM_BITMAP_0,    /* Choose recommended mem bitmap  */
-                .scrambleValue      = 0xFEDCBA9876543210U, /* Scramble Value */
-            },
-        },
+        .testName               = "MCU PULSAR PBIST",
+        .pbistInst              = SDL_PBIST_INST_MCUR5F1,
+        .numPostPbistToCheck    = 0u,
         .tisciPBISTDeviceId     = TISCI_DEV_MCU_PBIST1,       /* PBIST device id */
-        .interruptNumber        = CSLR_MCU_R5FSS0_CORE0_INTR_MCU_PBIST1_DFT_PBIST_CPU_0,
         .procRstNeeded          = false,
         .secondaryCoreNeeded    = false,                   /* Secondary core needed */
         .coreCustPwrSeqNeeded   = false,
         .numAuxDevices          = 0u,                      /* No Aux devices */
         .auxInitRestoreFunction = NULL,                    /* Auxilliary init/restore function */
-        .doneFlag               = false,                   /* Initialize done flag */
     },
 #endif
 };
@@ -890,8 +533,7 @@ int32_t PBIST_A72AuxInitRestore(bool init)
     result = CSL_ratConfigRegionTranslation((CSL_ratRegs *)PBIST_RAT_CFG_BASE,
                                             PBIST_RAT_REGION2_INDEX, &translationCfg);
     if (result == false) {
-        AppUtils_Printf(MSG_NORMAL,
-                        "   CSL_ratConfigRegionTranslation...FAILED \n");
+        UART_printf("   CSL_ratConfigRegionTranslation...FAILED \n");
         testResult = -1;
     }
 
@@ -912,8 +554,7 @@ int32_t PBIST_A72AuxInitRestore(bool init)
         result = CSL_ratDisableRegionTranslation((CSL_ratRegs *)PBIST_RAT_CFG_BASE,
                                                  PBIST_RAT_REGION2_INDEX);
         if (result == false) {
-            AppUtils_Printf(MSG_NORMAL,
-                            "   CSL_ratDisableRegionTranslation...FAILED \n");
+            UART_printf("   CSL_ratDisableRegionTranslation...FAILED \n");
             testResult = -1;
         }
     }
@@ -967,9 +608,11 @@ int32_t PBIST_decoderAuxInitRestore(bool init)
 
     if (init)
     {
-        *((uint32_t *)(((uint32_t)localP) + 0x440)) = 0xffff0113;
-        *((uint32_t *)(((uint32_t)localP) + 0x444)) = 0x00000000;
-        *((uint32_t *)(((uint32_t)localP) + 0x24020)) = 0x00070840;
+        *((uint32_t *)(((uint32_t)localP) + 0x440)) = 0xffffffff;
+        *((uint32_t *)(((uint32_t)localP) + 0x444)) = 0xffffffff;
+        *((uint32_t *)(((uint32_t)localP) + 0x24020)) = 0xffffffff;
+        *((uint32_t *)(((uint32_t)localP) + 0x4020)) = 0xffffffff;
+        *((uint32_t *)(((uint32_t)localP) + 0x3020)) = 0xffffffff;
     }
     else
     {
@@ -996,8 +639,7 @@ int32_t PBIST_GPUAuxInitRestore(bool init)
     result = CSL_ratConfigRegionTranslation((CSL_ratRegs *)PBIST_RAT_CFG_BASE,
                                             PBIST_RAT_REGION2_INDEX, &translationCfg);
     if (result == false) {
-        AppUtils_Printf(MSG_NORMAL,
-                        "   CSL_ratConfigRegionTranslation...FAILED \n");
+        UART_printf("   CSL_ratConfigRegionTranslation...FAILED \n");
         testResult = -1;
     }
 
@@ -1005,7 +647,7 @@ int32_t PBIST_GPUAuxInitRestore(bool init)
     {
         if (init)
         {
-            *((uint64_t *)(((uint32_t)localP) + 0xA100)) = 0xffff0113;
+            *((uint64_t *)(((uint32_t)localP) + 0xA100)) = 0x0;
 
             while(*((uint64_t *)(((uint32_t)localP) + 0xA100)) !=  (uint64_t)0x0);
             *((uint64_t *)(((uint32_t)localP) + 0x00)) = 0x0555550015155555;
@@ -1022,11 +664,38 @@ int32_t PBIST_GPUAuxInitRestore(bool init)
         result = CSL_ratDisableRegionTranslation((CSL_ratRegs *)PBIST_RAT_CFG_BASE,
                                                  PBIST_RAT_REGION2_INDEX);
         if (result == false) {
-            AppUtils_Printf(MSG_NORMAL,
-                            "   CSL_ratDisableRegionTranslation...FAILED \n");
+            UART_printf("   CSL_ratDisableRegionTranslation...FAILED \n");
             testResult = -1;
         }
     }
 
     return testResult;
 }
+
+char * PBIST_getPostStatusString(SDL_PBIST_postStatus postStatus)
+{
+    if (postStatus == SDL_PBIST_POST_NOT_RUN)
+    {
+        return PBIST_POST_NOT_RUN_STR;
+    }
+    else if (postStatus == SDL_PBIST_POST_TIMEOUT)
+    {
+        return PBIST_POST_ATTEMPTED_TIMEOUT_STR;
+    }
+    else if (postStatus == SDL_PBIST_POST_COMPLETED_FAILURE)
+    {
+        return PBIST_POST_COMPLETED_FAILURE_STR;
+    }
+    else if (postStatus == SDL_PBIST_POST_COMPLETED_SUCCESS)
+    {
+        return PBIST_POST_COMPLETED_SUCCESS_STR;
+    }
+    return NULL;
+}
+
+void PBIST_printPostStatus(SDL_PBIST_postResult *result)
+{
+    UART_printf("    HW POST MCU Status : %s\n", (PBIST_getPostStatusString(result->mcuPostStatus)) ? : "Invalid");
+
+    return;
+}
diff --git a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.h b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.h
index fd0427c8d5396e845890c136b666099b468ac9e6..881dc30f476b6a6b37e6a3099973d8775920de1e 100644
--- a/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.h
+++ b/psdkra/mcusw/mcuss_demos/boot_app_mcu_rtos/soc/j721e/pbist_defs.h
@@ -1,5 +1,5 @@
 /********************************************************************
- * Copyright (C) 2020 Texas Instruments Incorporated.
+ * Copyright (C) 2022 Texas Instruments Incorporated.
  *
  *  Redistribution and use in source and binary forms, with or without
  *  modification, are permitted provided that the following conditions
@@ -52,16 +52,17 @@ extern "C"
 /* ========================================================================== */
 /*                           Macros & Typedefs                                */
 /* ========================================================================== */
+
+#define PBIST_REGION_LOCAL_BASE           (0x60000000u)
+
+#define PBIST_REGION2_LOCAL_BASE          (0x68000000u)
+
 #define PBIST_RAT_REGION_INDEX            0
 #define PBIST_RAT_REGION2_INDEX           1
 
 #define PBIST_REG_REGION_SIZE             (0x400u)
 #define PBIST_REG_REGION2_SIZE            (0x10000u)
 
-#define PBIST_MAX_TIMEOUT_VALUE           (100000000u)
-
-#define PBIST_MAX_NUM_RUNS                2
-
 /* Firewall definitions */
 #define FW_REGION_ENABLE                  (0xAU)
 #define FW_MCU_R5F0_PRIVID                (96U)
@@ -78,13 +79,8 @@ typedef int32_t (*PBIST_auxInitRestoreFunctionPtr)(bool init);
 typedef struct PBIST_TestHandle_s
 {
     char               testName[PBIST_INSTANCE_NAME_MAX_LENGTH];
-    uint64_t           PBISTRegsHiAddress;
-    uint64_t           deviceRegsHiAddress;
-    CSL_pbistRegs     *pPBISTRegs;
-    CSL_PBIST_config_t PBISTConfigRun[PBIST_MAX_NUM_RUNS];
-    uint32_t           numPBISTRuns;
+    SDL_PBIST_inst     pbistInst;
     uint32_t           tisciPBISTDeviceId;
-    uint32_t           interruptNumber;
     bool               procRstNeeded;
     bool               secondaryCoreNeeded;
     char               coreName[16];
@@ -93,7 +89,6 @@ typedef struct PBIST_TestHandle_s
     uint32_t           tisciSecProcId;
     uint32_t           tisciDeviceId;
     uint32_t           tisciSecDeviceId;
-    volatile bool      doneFlag;
     bool               coreCustPwrSeqNeeded;
     uint8_t            numPostPbistToCheck;
     uint32_t           numAuxDevices;
@@ -107,7 +102,7 @@ extern PBIST_TestHandle_t PBIST_TestHandleArray[PBIST_MAX_INSTANCE+1];
 /*                          Function Declarations                             */
 /* ========================================================================== */
 
-/* None */
+void PBIST_printPostStatus(SDL_PBIST_postResult *result);
 
 #ifdef __cplusplus
 }
